/*
 *  libxcpc by Davide Libenzi (Exception and resource handling in C)
 *  Copyright (C) 2002  Davide Libenzi
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Davide Libenzi <davidel@xmailserver.org>
 *
 */

#if !defined(_XCPC_MACROS_H)
#define _XCPC_MACROS_H


#define XCM_ZERODATA(d) memset(&(d), 0, sizeof(d))
#define XCM_COUNTOF(a) (sizeof(a) / sizeof(a[0]))
#define XCM_MIN(a, b) ((a) < (b) ? (a): (b))
#define XCM_MAX(a, b) ((a) > (b) ? (a): (b))
#define XCM_ABS(a) ((a) > 0 ? (a): -(a))
#define XCM_OFFSETOF(typ, fld) ((unsigned long) (&((typ *) 0)->fld))
#define XCM_CONTAINER(ptr, typ, fld) ((typ *)((char *)(ptr) - XCM_OFFSETOF(typ, fld))


#endif

